<nz-card nzSize="small" nzTitle="Map editor">
  <nz-spin [nzSpinning]="isLoading">

    <div nz-row nzGutter="8">
      <div nz-col nzSpan="6" style="text-align: center;">
        <h3>{{'Common.Maps.Mode' | translate }}</h3>
        <nz-select [(ngModel)]="mode" nzSize="small" style="width: 100%" (ngModelChange)="onModeSwitch($event)"
          [nzDisabled]="modifyData">
          <nz-option nzValue="view" [nzLabel]="'Common.Maps.viewMap' | translate"></nz-option>
          <nz-option nzValue="create" [nzLabel]="'Common.Maps.createNewRegion' | translate"></nz-option>
          <nz-option nzValue="modify" [nzLabel]="'Common.Maps.modifyExistingRegion' | translate"></nz-option>
          <nz-option nzValue="delete" [nzLabel]="'Common.Maps.deleteRegion' | translate"></nz-option>
          <nz-option nzValue="borders" [nzLabel]="'Common.Maps.regionBordersControl' | translate"></nz-option>
          <nz-option nzValue="resources" [nzLabel]="'Common.Maps.regionResourcesControl' | translate"></nz-option>
        </nz-select>

        <div *ngIf="mode === 'resources'">
          <h4>{{'Economy.Resource.Title' | translate }}: </h4>

          <nz-select [(ngModel)]="resourcesMapFilterValue" nzSize="small" style="width: 100%"
            (ngModelChange)="resourcesMapFilterValueChange($event)">
            <nz-option nzValue="" [nzLabel]="'Common.Maps.All' | translate"></nz-option>
            <nz-option *ngFor="let r of availableResources" [nzValue]="r.itemId" [nzLabel]="r.symbol"></nz-option>
          </nz-select>

        </div>

      </div>
      <div nz-col nzSpan="18" style="text-align: center;" *ngIf="mode === 'create' || mode === 'modify'">
        <form nz-form [formGroup]="createRegionForm">
          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.regionName' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              <input nz-input size="small" formControlName="name" />
            </nz-form-control>
          </nz-form-item>

          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.capitalNamealone' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              <input nz-input size="small" formControlName="capitalName" />
            </nz-form-control>
          </nz-form-item>

          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.capitalCoords' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              <input nz-input size="small" formControlName="capitalCoords" placeholder="Lat, long" />
            </nz-form-control>
          </nz-form-item>

          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.currentCountry' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              <nz-select formControlName="countryId" nzSize="small" style="width: 100%">
                <nz-option *ngFor="let item of countries" [nzValue]="item.id" [nzLabel]="item.name"></nz-option>
              </nz-select>
            </nz-form-control>
          </nz-form-item>

          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.coreCountry' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              <nz-select formControlName="coreCountryId" nzSize="small" style="width: 100%">
                <nz-option *ngFor="let item of countries" [nzValue]="item.id" [nzLabel]="item.name"></nz-option>
              </nz-select>
            </nz-form-control>
          </nz-form-item>

          <nz-form-item>
            <nz-form-label [nzSpan]="6" nzFor="email">{{'Common.Maps.currentCoordsCount' | translate}}</nz-form-label>
            <nz-form-control [nzSpan]="14">
              {{ createRegionForm.get('paths').value?.length - 1 }}
              <button *ngIf="createRegionForm.get('paths').value?.length > 0" nz-button nzDanger type="button"
                nzShape="round" nzSize="small" (click)="clearRegionCoords()">{{'Common.Maps.clearPolygon' |
                translate}}</button>
            </nz-form-control>
          </nz-form-item>

          <nz-form-control style="text-align: center;">
            <button *ngIf="mode === 'create'" nz-button nzDanger nzShape="round" (click)="createPathSubmit()"
              [disabled]="createRegionForm.status === 'INVALID'">
              {{'Common.Maps.submitChanges' | translate}} </button>

            <button *ngIf="mode === 'modify'" nz-button nzDanger nzShape="round" (click)="updatePathSubmit()"
              [disabled]="createRegionForm.status === 'INVALID'">
              {{'Common.Maps.submitChanges' | translate}}
            </button>
          </nz-form-control>

        </form>

      </div>

      <div nz-col nzSpan="18" style="text-align: center;" *ngIf="mode === 'delete'">
        <button nz-button nzDanger nzShape="round" (click)="deletePathSubmit()" [disabled]="!deleteId">{{'Common.Delete'
          | translate}}</button>
      </div>


      <div nz-col nzSpan="18" style="text-align: center;" *ngIf="mode === 'borders' && currentSelectedRegion">
        <h3>{{'Common.Maps.selectedRegion' | translate}}: {{ currentSelectedRegion?.name }} ({{ currentSelectedRegion?.country?.name }})</h3>

        <div nz-flex nzJustify="space-evenly">
          <div class="flex-item">
            <button nz-button nzShape="round" nzSize="small" *ngIf="currentSelectedRegion"
              (click)="addingNewBorder = !addingNewBorder">
              {{ addingNewBorder ? 'Common.Maps.stopAddingBorders' : 'Common.Maps.addBorderConnection' | translate }}
            </button>
          </div>
        </div>

        <nz-table #bordersTable [nzData]="borders" nzSize="small">
          <thead>
            <tr>
              <th nzAlign="center">{{'Common.Color' | translate}}</th>
              <th nzAlign="center">{{'Common.Region' | translate}}</th>
              <th nzAlign="center">{{'Economy.Market.Country' | translate}}</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <tr *ngFor="let data of bordersTable.data">
              <td nzAlign="center" style="text-align: center;">
                <div style="width: 15px; height: 15px;" [style.backgroundColor]="data.color"></div>
              </td>
              <td nzAlign="center">{{data.name}}</td>
              <td nzAlign="center">{{data.country?.name}}</td>
              <td nzAlign="center">
                <button nz-button nzDanger nzShape="round" nzSize="small" (click)="removeBorderSubmit(data.id)">
                  {{'Common.Delete' | translate}}
                </button>
              </td>
            </tr>
          </tbody>
        </nz-table>
      </div>

      <div nz-col nzSpan="18" style="text-align: center;" *ngIf="mode === 'resources' && currentSelectedRegion">
        <h3>{{'Common.Maps.selectedRegion' | translate}}: {{ currentSelectedRegion?.name }} ({{ currentSelectedRegion?.country?.name }})</h3>

        <div nz-flex nzJustify="space-evenly">
          <div class="flex-item" *ngFor="let item of currentSelectedRegion.resources">
            <div style="text-align: center;">
              <img [alt]="item.symbol" [src]="item.value" width="30" height="30" />
              <nz-select nzSize="small" style="width: 100%" [(ngModel)]="item.quality">
                <nz-option *ngFor="let q of [0, 1, 2, 3]" [nzValue]="q" [nzLabel]="q"></nz-option>
              </nz-select>
            </div>
          </div>
        </div>

        <button nz-button nzDanger nzShape="round" (click)="updateResourcesSubmit()" style="margin-top: 5px">
          {{'Common.Maps.updateResources' | translate}}
        </button>

      </div>

    </div>

    <nz-divider></nz-divider>

    <div [style.minHeight]="mapHeight">
      <div id="legacy-map-editor-id" style="width: 100%;" [style.height]="mapHeight">
      </div>
    </div>

  </nz-spin>
</nz-card>